#INCLUDE "dcdialog.ch"

#DEFINE _METHOD   METHOD

#define PBS_MARQUEE       0x08
#define PBS_SMOOTH        0x01
#define PBS_NORMAL        0x00

#IFDEF DXE
CLASS DC_XbpProgressBar FROM DXE_ProgressBar, DC_XbaseParts
#ELSE
CLASS DC_XbpProgressBar FROM DC_XbpProgressBarSuper, DC_XbaseParts
#ENDIF

EXPORTED:

#IFDEF DXE

  // redirect to use same iVar from DXE_ProgressBar
  //
#ELSE
  VAR percent                                    // -> DXE
  VAR maxCount                                   // -> DXE
  VAR currCount                                  // -> DXE
  VAR every                                      // -> DXE
  VAR vertical                                   // -> DXE
#ENDIF

  VAR barColor
  VAR backColor
  VAR optionArray
  VAR presSpace
  VAR percentFont
  VAR percentColor
  VAR radius
  VAR outline
  VAR dynamic
  _METHOD init, create
ENDCLASS

* ------------------

METHOD DC_XbpProgressBar:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, aColor, aGetList, aGetListItem

#IFDEF DXE
   ::DXE_ProgressBar:init( oParent, oOwner, aPos, aSize, aPres, lVisible )
#ELSE
   ::XbpStatic:init( oParent, oOwner, aPos, aSize, aPres, lVisible )
#ENDIF

::tabstop  := .F.
::vertical := .F.
::percent  := .F.
::barColor := GRA_CLR_BLUE
::backColor := GRA_CLR_BACKGROUND
::percentColor := GRA_CLR_WHITE
::percentFont := '8.Arial Bold'

IF Valtype(oGetList) == 'O'

  ::DC_XbaseParts:init( oGetList,,self )

  aGetList := ::getList:getListArray
  aGetListItem := ::getList:getListArray[::getListPointer]

  xOptions := aGetListItem[xGETLIST_OPTIONS]

  IF Valtype(aGetListItem[nGETLIST_SUBTYPE]) = 'N'
    ::type := aGetListItem[nGETLIST_SUBTYPE]
  ELSE
    ::type := XBPSTATIC_TYPE_RAISEDBOX
  ENDIF

  ASize(xOptions,4)

  DEFAULT xOptions[1] := 1
  DEFAULT xOptions[2] := .f.  // Show Percentage box
  DEFAULT xOptions[3] := 1
  DEFAULT xOptions[4] := .f.  // Vertical
  IF xOptions[3] <= 0
    xOptions[3] := 1
  ENDIF

  ::optionArray := xOptions

  aColor := aGetListItem[aGETLIST_COLOR]
  IF Valtype(aColor) = 'B'
    aColor := Eval(aColor)
  ENDIF
  IF Valtype(aColor) = 'N'
    aColor :=  { aColor, GRA_CLR_PALEGRAY }
  ELSEIF Valtype(aColor) = 'A'
    ASize(aColor,2)
  ELSE
    aColor := { GRA_CLR_DARKBLUE, GRA_CLR_PALEGRAY }
  ENDIF
  DEFAULT aColor[1] := GRA_CLR_DARKBLUE, ;
          aColor[2] := GRA_CLR_PALEGRAY

  ::every         := Int(xOptions[3])
  ::barColor      := aColor[1]
  ::backColor     := aColor[2]
  ::vertical      := xOptions[4]

// work in DXE as
//
// ACCESS METHOD DC_GetMaximum() VAR maxCount
// ASSIGN METHOD DC_SetMaximum() VAR maxCount
//
  ::maxCount      := xOptions[1]                 // -> DXE

  ::percent       := ::optionArray[2]
  ::percentFont   := aGetListItem[cGETLIST_FONT]
  ::percentColor  := aGetListItem[xGETLIST_OPTIONS2]
  ::radius        := aGetListItem[xGETLIST_OPTIONS3]
  ::dynamic       := aGetListItem[xGETLIST_OPTIONS4]
  ::outline       := aGetListITem[xGETLIST_OPTIONS5]

  ::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
  IF Valtype( bBlock ) = 'B'
    Eval( bBlock, self )
  ENDIF

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
  IF Valtype(bBlock) = 'B'
    Eval( bBlock, self )
  ENDIF

ENDIF

// work in DXE as
//
// ASSIGN METHOD DC_SetData() VAR currCount
// ACCESS METHOD DC_GetData() VAR currCount
//
::currCount       := 0                           // -> DXE

::clipChildren    := .t.

DEFAULT ::outline := .F., ;
        ::dynamic := .F.

IF Valtype(::percentColor) = 'B'
  ::percentColor := Eval(::percentColor)
ENDIF

#IFDEF DXE
   // default XBP_ORIENT_HORIZONTAL
   ::vertical    := xOptions[4]
   IF ::vertical == .T.
      ::nOrientation := XBP_ORIENT_VERTICAL
   ENDIF
#ENDIF

RETURN self

* --------------------

METHOD DC_XbpProgressBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL nWidth, nHeight, oPS, oFont

#IFDEF DXE
*  ::UseVisualStyle := .T.
   ::DXE_ProgressBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

   // more DXE_Progressbar Member
   //
   //  ::Style            := PBS_SMOOTH
   //  ::Minimum          := 0
   //  ::Maximum          := ::maxCount -> now in DXE
   //  ::nScaleMax        := 100
   //  ::Increment        := ::Every    -> now in DXE
#ELSE

   ::xbpStatic:create( oParent, oOwner, aPos, aSize, aPres, lVisible )
#ENDIF

   IF !Empty(::percentFont)
      ::presSpace := ::lockPS()
     IF Valtype(::percentfont) == 'C'
       oFont := GraSetFont(::presSpace)
       oFont := DC_FontConfigure( oFont, ::percentFont, nil, ::presSpace )
       GraSetFont( ::presSpace, oFont )
     ELSEIF Valtype(::percentFont) == 'O'
       GraSetFont( ::presSpace, ::percentFont )
     ENDIF
   ENDIF

   ::DC_XbaseParts:setOrig(self)

   ::paint := {||DC_GetProgress(self,::currCount,::maxCount)}

RETURN self

* ------------------

